Index: src/isdn/include/Q931.h
===================================================================
--- src/isdn/include/Q931.h	(revision 495)
+++ src/isdn/include/Q931.h	(working copy)
@@ -209,15 +209,15 @@
 
 *****************************************************************************/
 
-#define L3UCHAR		unsigned char		/* Min 8 bit						*/
-#define L3USHORT	unsigned short		/* Min 16 bit unsigned				*/
-#define L3UINT		unsigned int		/* Min 16 bit unsigned	            */
-#define L3INT       int                 /* Min 16 bit signed                */
-#define L3ULONG		unsigned long		/* Min 32 bit						*/
-#define L3BOOL      char				/* Min 1 bit, valuse 0 & 1 only		*/
+#define L3UCHAR		unsigned char		/* Min 8 bit			*/
+#define L3USHORT	unsigned short		/* Min 16 bit unsigned		*/
+#define L3UINT		unsigned int		/* Min 16 bit unsigned		*/
+#define L3INT		int			/* Min 16 bit signed		*/
+#define L3ULONG		unsigned long		/* Min 32 bit			*/
+#define L3BOOL		char			/* Min 1 bit, valuse 0 & 1 only	*/
 
-#define L3TRUE      1
-#define L3FALSE     0 
+#define L3TRUE		1
+#define L3FALSE		0 
 
 /*****************************************************************************
 
@@ -244,24 +244,25 @@
 
 *****************************************************************************/
 
-#define Q931L4BUF  1000             /* size of message buffer               */
+#define	Q931_LOGBUFSIZE		1024	/* size of logging buffer */
 
-#define Q931L2BUF	300				/* size of message buffer				*/
+#define Q931L4BUF		1000	/* size of message buffer               */
 
-#define Q931MAXTRUNKS	4			/* Total number of trunks that will be	*/
-									/* processed by this instance of the	*/
-									/* stack								*/
+#define Q931L2BUF		300	/* size of message buffer		*/
 
-#define Q931MAXCHPERTRUNK	32		/* Number of channels per trunk. The	*/
-									/* stack uses a static set of 32		*/
-									/* channels regardless if it is E1, T1	*/
-									/* or BRI that actually is used.		*/
+#define Q931MAXTRUNKS		4	/* Total number of trunks that will be	*/
+					/* processed by this instance of the	*/
+					/* stack				*/
 
-#define Q931MAXCALLPERTRUNK (Q931MAXCHPERTRUNK * 2)
-                                    /* Number of max active CRV per trunk.  */
-									/* Q.931 can have more calls than there */
-									/* are channels.						*/
+#define Q931MAXCHPERTRUNK	32	/* Number of channels per trunk. The	*/
+					/* stack uses a static set of 32	*/
+					/* channels regardless if it is E1, T1	*/
+					/* or BRI that actually is used.	*/
 
+#define Q931MAXCALLPERTRUNK (Q931MAXCHPERTRUNK * 2)	/* Number of max active CRV per trunk.  */
+							/* Q.931 can have more calls than there */
+							/* are channels.			*/
+
 /*****************************************************************************
 
   The following defines control the dialect switch tables and should only be
@@ -280,25 +281,26 @@
 
 *****************************************************************************/
 
-/* WARNING! Initialize Q931CreateDialectCB[] will NULL when increasing the  */
-/* Q931MAXDLCT value to avoid Q931Initialize from crashing if one entry is  */
-/* not used.																*/
-#define Q931MAXDLCT 8           /* Max dialects included in this        */
-                                /* compile. User and Network count as   */
-                                /* one dialect each.                    */
+/* WARNING! Initialize Q931CreateDialectCB[] will NULL when increasing the	*/
+/* Q931MAXDLCT value to avoid Q931Initialize from crashing if one entry is	*/
+/* not used.									*/
 
+#define Q931MAXDLCT	8		/* Max dialects included in this        */
+					/* compile. User and Network count as   */
+					/* one dialect each.                    */
 
-#define Q931MAXMES  128         /* Number of messages							*/
 
-#define Q931MAXIE  255          /* Number of IE									*/
+#define Q931MAXMES	128		/* Number of messages			*/
 
-#define Q931MAXUSEDIE 50		/* Maximum number of ie types per Dialect		*/
+#define Q931MAXIE	255		/* Number of IE				*/
 
-#define Q931MAXCODESETS 7		/* Maximum number of codests (by spec, 0-7)		*/
+#define Q931MAXUSEDIE	50		/* Maximum number of ie types per Dialect	*/
 
-#define Q931MAXSTATE 100		/* Size of state tables					        */
+#define Q931MAXCODESETS	7		/* Maximum number of codests (by spec, 0-7)	*/
 
+#define Q931MAXSTATE	100		/* Size of state tables			*/
 
+
 /*****************************************************************************
 
   Call States for ITU-T Q.931 TE (User Mode)
@@ -371,7 +373,7 @@
 #define Q931mes_RESTART              0x46 /* 0100 0110                   */
 #define Q931mes_RESTART_ACKNOWLEDGE  0x4e /* 0100 1110                   */
 #define Q931mes_CONGESTION_CONTROL   0x79 /* 0111 1001                   */
-#define Q931mes_INFORMATION          0x7a /* 0111 1011                   */
+#define Q931mes_INFORMATION          0x7b /* 0111 1011                   */
 #define Q931mes_NOTIFY               0x6e /* 0110 1110                   */
 #define Q931mes_STATUS               0x7d /* 0111 1101                   */
 #define Q931mes_STATUS_ENQUIRY       0x75 /* 0111 0101                   */
@@ -390,12 +392,12 @@
 *****************************************************************************/
 typedef struct
 {
-    L3UINT			Size;           /* Size of message in bytes             */
-    L3UCHAR         ProtDisc;       /* Protocol Discriminator               */
-    L3UCHAR         MesType;        /* Message type                         */
-    L3UCHAR         CRVFlag;        /* Call reference value flag            */
-    L3INT           CRV;            /* Call reference value                 */
-}Q931mes_Header;
+	L3UINT		Size;		/* Size of message in bytes             */
+	L3UCHAR		ProtDisc;	/* Protocol Discriminator               */
+	L3UCHAR		MesType;	/* Message type                         */
+	L3UCHAR		CRVFlag;	/* Call reference value flag            */
+	L3INT		CRV;		/* Call reference value                 */
+} Q931mes_Header;
 
 /*****************************************************************************
 
@@ -407,53 +409,53 @@
 *****************************************************************************/
 typedef struct
 {
-    L3UINT			Size;           /* Size of message in bytes             */
-    L3UCHAR         ProtDisc;       /* Protocol Discriminator               */
-    L3UCHAR         MesType;        /* Message type                         */
-    L3UCHAR         CRVFlag;        /* Call reference value flag            */
-    L3INT           CRV;            /* Call reference value                 */
+	L3UINT		Size;           /* Size of message in bytes             */
+	L3UCHAR         ProtDisc;       /* Protocol Discriminator               */
+	L3UCHAR         MesType;        /* Message type                         */
+	L3UCHAR         CRVFlag;        /* Call reference value flag            */
+	L3INT           CRV;            /* Call reference value                 */
 
-    ie              Shift;
-    ie              MoreData;
-    ie              SendComplete;
-    ie              CongestionLevel;
-    ie              RepeatInd;
+	ie              Shift;
+	ie              MoreData;
+	ie              SendComplete;
+	ie              CongestionLevel;
+	ie              RepeatInd;
 
-    ie              Segment;        /* Segmented message                    */
-    ie              BearerCap;      /* Bearer Capability                    */
-    ie              Cause;          /* Cause                                */
-    ie              CallState;      /* Call State                           */
-    ie              CallID;			/* Call Identity                        */
-    ie              ChanID;         /* Channel Identification               */
-    ie              ChangeStatus;   /* Change Staus                         */
-    ie              ProgInd;        /* Progress Indicator                   */
-    ie              NetFac;         /* Network Spesific Facilities          */
-    ie              NotifInd;       /* Notification Indicator               */
-    ie              Display;        /* Display                              */
-    ie              DateTime;       /* Date/Time                            */
-    ie              KeypadFac;      /* Keypad Facility                      */
-    ie              Signal;         /* Signal                               */
-    ie              InfoRate;       /* Information rate                     */
-    ie              EndEndTxDelay;  /* End to End Transmit Delay            */
-    ie              TransDelSelInd; /* Transmit Delay Sel. and Ind.         */
-    ie              PackParam;      /* Packed Layer Binary parameters       */
-    ie              PackWinSize;    /* Packet Layer Window Size             */
-    ie              PackSize;       /* Packed Size                          */
-    ie              ClosedUserGrp;  /* Closed User Group                    */
-    ie              RevChargeInd;   /* Reverse Charging Indicator           */
-    ie              CalledNum;      /* Called Party Number                  */
-    ie              CalledSub;      /* Called Party subaddress              */
-    ie              CallingNum;     /* Calling Party Number                 */
-    ie              CallingSub;     /* Calling Party Subaddress             */
-    ie              RedirNum;       /* Redirection Number                   */
-    ie              TransNetSel;    /* Transmit Network Selection           */
-    ie              LLRepeatInd;    /* Repeat Indicator 2 LLComp            */
-    ie              RestartWin;     /* Restart Window                       */
-    ie              RestartInd;     /* Restart Indicator                    */
-    ie              LLComp;         /* Low Layer Compatibility              */
-    ie              HLComp;         /* High Layer Compatibility             */
-    ie              UserUser;       /* User-user                            */
-    ie              Escape;         /* Escape for extension                 */
+	ie              Segment;        /* Segmented message                    */
+	ie              BearerCap;      /* Bearer Capability                    */
+	ie              Cause;          /* Cause                                */
+	ie              CallState;      /* Call State                           */
+	ie              CallID;		/* Call Identity                        */
+	ie              ChanID;         /* Channel Identification               */
+	ie              ChangeStatus;   /* Change Staus                         */
+	ie              ProgInd;        /* Progress Indicator                   */
+	ie              NetFac;         /* Network Spesific Facilities          */
+	ie              NotifInd;       /* Notification Indicator               */
+	ie              Display;        /* Display                              */
+	ie              DateTime;       /* Date/Time                            */
+	ie              KeypadFac;      /* Keypad Facility                      */
+	ie              Signal;         /* Signal                               */
+	ie              InfoRate;       /* Information rate                     */
+	ie              EndEndTxDelay;  /* End to End Transmit Delay            */
+	ie              TransDelSelInd; /* Transmit Delay Sel. and Ind.         */
+	ie              PackParam;      /* Packed Layer Binary parameters       */
+	ie              PackWinSize;    /* Packet Layer Window Size             */
+	ie              PackSize;       /* Packed Size                          */
+	ie              ClosedUserGrp;  /* Closed User Group                    */
+	ie              RevChargeInd;   /* Reverse Charging Indicator           */
+	ie              CalledNum;      /* Called Party Number                  */
+	ie              CalledSub;      /* Called Party subaddress              */
+	ie              CallingNum;     /* Calling Party Number                 */
+	ie              CallingSub;     /* Calling Party Subaddress             */
+	ie              RedirNum;       /* Redirection Number                   */
+	ie              TransNetSel;    /* Transmit Network Selection           */
+	ie              LLRepeatInd;    /* Repeat Indicator 2 LLComp            */
+	ie              RestartWin;     /* Restart Window                       */
+	ie              RestartInd;     /* Restart Indicator                    */
+	ie              LLComp;         /* Low Layer Compatibility              */
+	ie              HLComp;         /* High Layer Compatibility             */
+	ie              UserUser;       /* User-user                            */
+	ie              Escape;         /* Escape for extension                 */
 	ie				Switchhook;
 	ie				FeatAct;
 	ie				FeatInd;
@@ -461,7 +463,7 @@
 
 	L3UCHAR			buf[1];			/* Buffer for IE's						*/
 
-}Q931mes_Generic;
+} Q931mes_Generic;
 
 
 /*****************************************************************************
@@ -479,13 +481,28 @@
 *****************************************************************************/
 typedef struct Q931_TrunkInfo Q931_TrunkInfo_t;
 
-typedef L3INT (*Q931TxCB_t) (void *,L3UCHAR *, L3INT);
-typedef L3INT (*Q931ErrorCB_t) (void *,L3INT,L3INT,L3INT);
+/*
+ * Logging
+ */
+typedef enum
+{
+	Q931_LOG_NONE = 0,
+	Q931_LOG_ERROR,
+	Q931_LOG_WARNING,
+	Q931_LOG_NOTICE,
+	Q931_LOG_INFO,
+	Q931_LOG_DEBUG
+} Q931LogLevel_t;
 
+typedef L3INT (*Q931Tx34CB_t) (void *, L3UCHAR *, L3INT);
+typedef L3INT (*Q931Tx32CB_t) (void *, L3INT, L3UCHAR *, L3INT);
+typedef L3INT (*Q931ErrorCB_t) (void *, L3INT, L3INT, L3INT);
+typedef L3INT (*Q931LogCB_t) (void *, Q931LogLevel_t, char *, L3INT);
+
 typedef enum						/* Network/User Mode.                   */
 {
-	Q931_TE=0,						/*  0 : User Mode                       */
-    Q931_NT=1						/*  1 : Network Mode                    */
+	Q931_TE=0,					/*  0 : User Mode                       */
+	Q931_NT=1					/*  1 : Network Mode                    */
 } Q931NetUser_t;
 
 typedef enum						/* Dialect enum                         */
@@ -493,124 +510,129 @@
 	Q931_Dialect_Q931     = 0,
 	Q931_Dialect_National = 2,
 	Q931_Dialect_DMS      = 4,
-	Q931_Dialect_5ESS     = 6,      /* Coming soon to a PRI stack near you! */
+	Q931_Dialect_5ESS     = 6,			/* Coming soon to a PRI stack near you! */
 
 	Q931_Dialect_Count
 } Q931Dialect_t;
-#define DIALECT_STRINGS "q931", "", "national", "", "dms","","5ess",""
+#define DIALECT_STRINGS "q931", "", "national", "", "dms", "", "5ess", ""
 Q931_STR2ENUM_P(q931_str2Q931Dialect_type, q931_Q931Dialect_type2str, Q931Dialect_t)
 
 typedef enum						/* Trunk Line Type.                     */
 {
 	Q931_TrType_E1=0,				/*  0 : E1 Trunk                        */
-    Q931_TrType_T1=1,				/*  1 : T1 Trunk                        */
-    Q931_TrType_J1=2,				/*  2 : J1 Trunk                        */
-    Q931_TrType_BRI=3				/*  3 : BRI Trunk                       */
+	Q931_TrType_T1=1,				/*  1 : T1 Trunk                        */
+	Q931_TrType_J1=2,				/*  2 : J1 Trunk                        */
+	Q931_TrType_BRI=3,				/*  3 : BRI Trunk                       */
+	Q931_TrType_BRI_PTMP=4				/*  4 : BRI Trunk                       */
 } Q931_TrunkType_t;
 
-typedef enum						/* Trunk State							*/
+typedef enum						/* Trunk State				*/
 {
-	Q931_TrState_NoAlignment=0,		/* Trunk not aligned					*/
-	Q931_TrState_Aligning=1,		/* Aligning in progress					*/
-	Q931_TrState_Aligned=2			/* Trunk Aligned						*/
+	Q931_TrState_NoAlignment=0,			/* Trunk not aligned			*/
+	Q931_TrState_Aligning=1,			/* Aligning in progress			*/
+	Q931_TrState_Aligned=2				/* Trunk Aligned			*/
 } Q931_TrunkState_t;
 
 typedef enum {
-	Q931_ChType_NotUsed=0,			/* Unused Channel						*/
-	Q931_ChType_B=1,				/* B Channel (Voice)					*/
-	Q931_ChType_D=2,				/* D Channel (Signalling)				*/
-	Q931_ChType_Sync=3				/* Sync Channel							*/
+	Q931_ChType_NotUsed=0,				/* Unused Channel			*/
+	Q931_ChType_B=1,				/* B Channel (Voice)			*/
+	Q931_ChType_D=2,				/* D Channel (Signalling)		*/
+	Q931_ChType_Sync=3				/* Sync Channel				*/
 } Q931_ChanType_t;
 
+
 struct Q931_TrunkInfo
 {
 	Q931NetUser_t NetUser;			/* Network/User Mode.                   */
 
-    Q931Dialect_t Dialect;			/* Q.931 Based dialect index.           */
+	Q931Dialect_t Dialect;			/* Q.931 Based dialect index.           */
 
 	Q931_TrunkType_t TrunkType;		/* Trunk Line Type.                     */
 
-	Q931TxCB_t	Q931Tx34CBProc;
-	Q931TxCB_t	Q931Tx32CBProc;
-	Q931ErrorCB_t Q931ErrorCBProc;
+	Q931Tx34CB_t	Q931Tx34CBProc;
+	Q931Tx32CB_t	Q931Tx32CBProc;
+	Q931ErrorCB_t   Q931ErrorCBProc;
+	Q931LogCB_t	Q931LogCBProc;
 	void *PrivateData32;
 	void *PrivateData34;
+	void *PrivateDataLog;
 
-	L3UCHAR     Enabled;            /* Enabled/Disabled                     */
-                                    /*  0 = Disabled                        */
-                                    /*  1 = Enabled                         */
+	Q931LogLevel_t	loglevel;
 
+	L3UCHAR     Enabled;			/* Enabled/Disabled                     */
+						/*  0 = Disabled                        */
+						/*  1 = Enabled                         */
+
 	Q931_TrunkState_t TrunkState;
 
-    L3INT       LastCRV;            /* Last used crv for the trunk.         */
+	L3INT	LastCRV;			/* Last used crv for the trunk.         */
 
-    L3UCHAR L3Buf[Q931L4BUF];		/* message buffer for messages to be    */
-                                    /* send from Q.931 L4.                  */
+	L3UCHAR L3Buf[Q931L4BUF];		/* message buffer for messages to be    */
+						/* send from Q.931 L4.                  */
 
-    L3UCHAR L2Buf[Q931L2BUF];		/* buffer for messages send to L2.      */
+	L3UCHAR L2Buf[Q931L2BUF];		/* buffer for messages send to L2.      */
 
 	/* The auto flags below switch on/off automatic Ack messages. SETUP ACK */
 	/* as an example can be sent by the stack in response to SETUP to buy   */
 	/* time in processing on L4. Setting this to true will cause the stack  */
-	/* to automatically send this.											*/
+	/* to automatically send this.						*/
 
 	L3BOOL	autoSetupAck;			/* Indicate if the stack should send    */
-									/* SETUP ACK or not. 0=No, 1 = Yes.		*/
+						/* SETUP ACK or not. 0=No, 1 = Yes.	*/
 
 	L3BOOL  autoConnectAck;			/* Indicate if the stack should send    */
-									/* CONNECT ACT or not. 0=No, 1=Yes.		*/
+						/* CONNECT ACT or not. 0=No, 1=Yes.	*/
 
 	L3BOOL  autoRestartAck;			/* Indicate if the stack should send    */
-									/* RESTART ACK or not. 0=No, 1=Yes.		*/
+						/* RESTART ACK or not. 0=No, 1=Yes.	*/
 
 	L3BOOL  autoServiceAck;			/* Indicate if the stack should send    */
-									/* SERVICE ACK or not. 0=No, 1=Yes.		*/
+						/* SERVICE ACK or not. 0=No, 1=Yes.	*/
 
 	/* channel array holding info per channel. Usually defined to 32		*/
 	/* channels to fit an E1 since T1/J1 and BRI will fit inside a E1.		*/
-    struct _charray
-    {
+	struct _charray
+	{
 		Q931_ChanType_t ChanType;	/* Unused, B, D, Sync */
 
-        L3UCHAR Available;          /* Channel Available Flag               */
-                                    /*  0 : Avaiabled                       */
-                                    /*  1 : Used                            */
+		L3UCHAR Available;		/* Channel Available Flag               */
+						/*  0 : Avaiabled                       */
+						/*  1 : Used                            */
 
-        L3INT   CRV;                /* Associated CRV                       */
+		L3INT   CRV;			/* Associated CRV                       */
 
-    }ch[Q931MAXCHPERTRUNK];
+	} ch[Q931MAXCHPERTRUNK];
 
-    /* Active Call information indentified by CRV. See Q931AllocateCRV for  */
-	/* initialization of call table.										*/
-    struct _ccarray
-    {
-        L3UCHAR InUse;              /* Indicate if entry is in use.         */
-                                    /*  0 = Not in Use                      */
-                                    /*  1 = Active Call.                    */
+	/* Active Call information indentified by CRV. See Q931AllocateCRV for  */
+	/* initialization of call table.					*/
+	struct _ccarray
+	{
+		L3UCHAR InUse;			/* Indicate if entry is in use.         */
+						/*  0 = Not in Use                      */
+						/*  1 = Active Call.                    */
 
-        L3UCHAR BChan;              /* Associated B Channel.                */
-									/* 0 - 31 valid B chan					*/
-									/* 255 = Not allocated					*/
+		L3UCHAR BChan;			/* Associated B Channel.                */
+						/* 0 - 31 valid B chan			*/
+						/* 255 = Not allocated			*/
 
-        L3INT   CRV;                /* Associated CRV.                      */
+		L3INT   CRV;			/* Associated CRV.                      */
 
-        L3UINT  State;              /* Call State.                          */
-									/*  0 is Idle, but other values are		*/
-									/*  defined per dialect.				*/
-									/*  Default usage is 1-99 for TE and    */
-									/*  101 - 199 for NT.					*/
+		L3UINT  State;			/* Call State.                          */
+						/*  0 is Idle, but other values are	*/
+						/*  defined per dialect.		*/
+						/*  Default usage is 1-99 for TE and    */
+						/*  101 - 199 for NT.			*/
         
-        L3ULONG Timer;              /* Timer in ms. The TimeTick will check */
-									/* if this has exceeded the timeout, and*/
-									/* if so call the timers timeout proc.	*/
+		L3ULONG Timer;			/* Timer in ms. The TimeTick will check */
+						/* if this has exceeded the timeout, and*/
+						/* if so call the timers timeout proc.	*/
 
-        L3USHORT TimerID;           /* Timer Identification/State           */
-									/* actual values defined by dialect		*/
-                                    /*  0 : No timer running                */
-                                    /*  ITU-T Q.931:301 - 322 Timer running */
+		L3USHORT TimerID;		/* Timer Identification/State           */
+						/* actual values defined by dialect	*/
+						/*  0 : No timer running                */
+						/*  ITU-T Q.931:301 - 322 Timer running */
+	} call[Q931MAXCALLPERTRUNK];
 
-    }call[Q931MAXCALLPERTRUNK];
-
 };
 
 /*****************************************************************************
@@ -894,8 +916,9 @@
 
 *****************************************************************************/
 void    Q931TimeTick(Q931_TrunkInfo_t *pTrunk, L3ULONG ms);
-L3INT   Q931Rx23(Q931_TrunkInfo_t *pTrunk, L3UCHAR * Mes, L3INT Size);
-L3INT   Q931Tx32(Q931_TrunkInfo_t *pTrunk, L3UCHAR * Mes, L3INT Size);
+L3INT   Q931Rx23(Q931_TrunkInfo_t *pTrunk, L3INT, L3UCHAR * Mes, L3INT Size);
+L3INT   Q931Tx32Data(Q931_TrunkInfo_t *pTrunk, L3UCHAR * Mes, L3INT Size);
+L3INT   Q931Tx32UnitData(Q931_TrunkInfo_t *pTrunk, L3UCHAR * Mes, L3INT Size);
 L3INT   Q931Rx43(Q931_TrunkInfo_t *pTrunk, L3UCHAR * Mes, L3INT Size);
 L3INT   Q931Tx34(Q931_TrunkInfo_t *pTrunk, L3UCHAR * Mes, L3INT Size);
 void    Q931SetError(Q931_TrunkInfo_t *pTrunk,L3INT ErrID, L3INT ErrPar1, L3INT ErrPar2);
@@ -965,8 +988,8 @@
 						Q931Dialect_t Dialect,
 						Q931NetUser_t NetUser,
 						Q931_TrunkType_t TrunkType,
-						Q931TxCB_t Q931Tx34CBProc,
-						Q931TxCB_t Q931Tx32CBProc,
+						Q931Tx34CB_t Q931Tx34CBProc,
+						Q931Tx32CB_t Q931Tx32CBProc,
 						Q931ErrorCB_t Q931ErrorCBProc,
 						void *PrivateData32,
 						void *PrivateData34);
@@ -986,6 +1009,11 @@
 L3INT Q931TxDummy(Q931_TrunkInfo_t *pTrunk, L3UCHAR * b, L3INT n);
 L3INT Q931ErrorDummy(void *priv, L3INT a, L3INT b, L3INT c);
 
+L3INT Q931Log(Q931_TrunkInfo_t *trunk, Q931LogLevel_t level, const char *fmt, ...);
 
+void Q931SetLogCB(Q931_TrunkInfo_t *trunk, Q931LogCB_t func, void *priv);
+void Q931SetLogLevel(Q931_TrunkInfo_t *trunk, Q931LogLevel_t level);
 
+L3INT Q931MesgHeader(Q931_TrunkInfo_t *pTrunk, Q931mes_Generic *mes, L3UCHAR *OBuf, L3INT Size, L3INT *IOff);
+
 #endif /* _Q931_NL */
